%Outlab 1 : Task B2 - solving the lights out! puzzle for any matrix
function x = backward_solve(b)
	k = size(b);						%size(b) returns the number of rows and columns
	if(k(1) < k(2))
		n = k(2);
	else
		n = k(1);
	endif
	
	%creating toggle matrix for the nxn matrix (row number or column number - whichever is bigger)
	A = zeros(n*n,n*n);				

	%part of the toggle matrix for cells not in the corners or the sides
	for i=2:n-1
		for j=2:n-1
			A(fij(i,j,n),fij(i,j,n)) = 1;					%f(i,j,n) returns the order assigned to a cell (i,j) in the board
			A(fij(i,j,n),fij(i-1,j,n)) = 1;
			A(fij(i,j,n),fij(i+1,j,n)) = 1;
			A(fij(i,j,n),fij(i,j+1,n)) = 1;
			A(fij(i,j,n),fij(i,j-1,n)) = 1;
		endfor
	endfor

	%part of the toggle matrix for cells on the sides 
	for j=2:n-1
		A(fij(1,j,n),fij(1,j-1,n)) = 1;
		A(fij(1,j,n),fij(1,j+1,n)) = 1;
		A(fij(1,j,n),fij(1,j,n)) = 1;
		A(fij(1,j,n),fij(2,j,n)) = 1;
	endfor
	for j=2:n-1
		A(fij(n,j,n),fij(n,j-1,n)) = 1;
		A(fij(n,j,n),fij(n,j+1,n)) = 1;
		A(fij(n,j,n),fij(n,j,n)) = 1;
		A(fij(n,j,n),fij(n-1,j,n)) = 1;
	endfor
	for i=2:n-1
		A(fij(i,1,n),fij(i+1,1,n)) = 1;
		A(fij(i,1,n),fij(i-1,1,n)) = 1;
		A(fij(i,1,n),fij(i,1,n)) = 1;
		A(fij(i,1,n),fij(i,2,n)) = 1;
	endfor
	for i=2:n-1
		A(fij(i,n,n),fij(i+1,n,n)) = 1;
		A(fij(i,n,n),fij(i-1,n,n)) = 1;
		A(fij(i,n,n),fij(i,n,n)) = 1;
		A(fij(i,n,n),fij(i,n-1,n)) = 1;
	endfor

	%part of the toggle matrix for cells in the corners
	A(fij(1,1,n),fij(1,1,n)) = 1;
	A(fij(1,1,n),fij(2,1,n)) = 1;
	A(fij(1,1,n),fij(1,2,n)) = 1;

	A(fij(1,n,n),fij(1,n,n)) = 1;
	A(fij(1,n,n),fij(1,n-1,n)) = 1;
	A(fij(1,n,n),fij(2,n,n)) = 1;

	A(fij(n,1,n),fij(n,1,n)) = 1;
	A(fij(n,1,n),fij(n-1,1,n)) = 1;
	A(fij(n,1,n),fij(n,2,n)) = 1;

	A(fij(n,n,n),fij(n,n,n)) = 1;
	A(fij(n,n,n),fij(n-1,n,n)) = 1;
	A(fij(n,n,n),fij(n,n-1,n)) = 1;
	
	%extracting that part of the toggle matrix relevant to the mxn matrix, for nxn matrix no change 
	A = A(1:k(1)*k(2),1:k(1)*k(2));

	%reshaping b to a column matrix
	b = b';
	b = reshape(b,k(1)*k(2),1);	
	
	%solving Ax + b = 0 mod 2 		  
	x = inv(A)*b*det(A);					%determinant is multiplied as matrix inverse in mod 2  or GF(2) (Galois field) 
											%is normal inverse*determinant 
	x = reshape(x,k(2),k(1));
	x = int64(x);							%to solve precision problems - changing the data type
	x = mod(x',2);
end